<?php declare(strict_types=1);

namespace Lubian\AttributeMagic;

use DI\ContainerBuilder;
use Lubian\AttributeMagic\Infrastructure\Event\Dispatcher;
use Lubian\AttributeMagic\Infrastructure\Event\DispatcherFactory;
use Lubian\AttributeMagic\Infrastructure\Finder;
use Lubian\AttributeMagic\Infrastructure\WebApp\Request\RequestEvent;
use Lubian\AttributeMagic\Infrastructure\WebApp\Route\HandlerResolver;
use Symfony\Component\HttpFoundation\Request;

use function assert;

require_once __DIR__ . '/../vendor/autoload.php';

$cached = false;
$container = (new ContainerBuilder)->addDefinitions([
    Finder::class => static fn (): Finder => new Finder(__DIR__, [], $cached),
    Dispatcher::class => static fn (DispatcherFactory $f): Dispatcher => $f->getDispatcher($cached),
    HandlerResolver::class => static fn (Dispatcher $d): HandlerResolver => new HandlerResolver($d, $cached),
])->build();
$dispatcher = $container->get(Dispatcher::class);
assert($dispatcher instanceof Dispatcher);
$request = new RequestEvent(Request::createFromGlobals());

$dispatcher->dispatch($request);

$request->response?->send();
exit;
