<?php declare(strict_types=1);

namespace Lubian\AttributeMagic\Infrastructure\WebApp\Route;

use Lubian\AttributeMagic\Infrastructure\Event\AsListener;
use Lubian\AttributeMagic\Infrastructure\Finder;

final readonly class AttributeRouteCollector
{
    public function __construct(
        private Finder $finder
    ) {
    }

    #[AsListener(CollectRoutes::class)]
    public function collect(CollectRoutes $event): void
    {
        $event->routes = $this->finder->getHandlers();
    }
}
